/*///+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
  , ,       , 
   ,     .
     ,      .

void transpose()   - 
void multiplying() - 
void inverse()     - 
void pull_line()   - h  
void pull_column() - v  
double minor_AD()  - ( )
double det()       - 
double ox()        - 1/X

void PRINTS()      -    
/*///+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|                                          Matrix_Solve_script.mq4 |
//|                                                            Urain |
//+------------------------------------------------------------------+
#property copyright "Urain"
#property link      ""
#property show_inputs

#import "Matrix_Solve_lib.ex4"
void transpose( double& a[], int n, int m);
void multiplying( double& a[], double& b[], int n, int q, int m);
void inverse( double& a[], int n);
void pull_line( double& a[], int h, int n, int m);
void pull_column( double& a[], int v, int n, int m);
double minor_AD( double a[], int n, int I, int J, bool fl=0);
double det( double a[], int n);
double ox( double x);
#import

extern int Matrix=5;
//--------------------------------------------------------------------------------- 
double A[9]={1,-2, 0,
             3, 4, 2,
            -1, 3, 1 };                    //  3x3
//---------------------------------------------------------------------------------            
double B[6]={ 2,  3,
              7,  8,
             12, 13 };                     // B 2x3
//---------------------------------------------------------------------------------              
double C[];
int start()
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
 
 int Count=MathPow(Matrix,2);
 ArrayResize(C,Count);
 for(int i=0;i<Count;i++)
     C[i]=Close[i];
 int start_=GetTickCount();    
 inverse( C, Matrix);//     , 
                     // Matrix > 100   . Matrix = 100    40 .
 int end_=GetTickCount(); 
 PRINTS( "Matrix_Solve_Close_inverse", Count, C); 
 //---------------------------------------------------------------------------------------------------    
 inverse( A, 3);                            //   
 PRINTS( "Matrix_Solve_inverse", 9, A);     //     Matrix_Solve_inverse
 
 multiplying( A, B, 3, 3, 2);               //       
 PRINTS( "Matrix_Solve_multiplying", 6, A); //     Matrix_Solve_multiplying
 
                                 //    2-     .
 Alert("end   . ",(end_-start_)*0.001, " . ");
return(0);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+



/*///09+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
                                                             
/*///09+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
void PRINTS( string files, int c, double y[])
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
int han = FileOpen(files+".txt", FILE_WRITE," "); 
if(han>0)
  {FileWrite(han," --------------------- --------------------- ");           
   for(int i=0;i<c;i++)
       FileWrite(han, y[i]);
   FileClose(han);
  }
return;
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

